﻿Imports Infragistics.Documents.Report.Section
Imports Infragistics.Documents.Report.Text
Imports Infragistics.Documents.Report
Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Documents.Report.Projection

Public Class Form1


    Dim pages As IProjectionPageCollection
    Dim currentPrintPageNumber As Integer


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim table As DataTable = New DataTable()
        For i As Integer = 0 To 6
            table.Columns.Add("Column" & i.ToString(), GetType(String)).DefaultValue = "Test Text"
        Next

        For i As Integer = 0 To 102
            table.Rows.Add((i Mod 3).ToString())
        Next

        UltraGrid1.DataSource = table

        UltraGrid1.DisplayLayout.Bands(0).SortedColumns.Add("Column0", False, True)

    End Sub


    Private Function GenerateReport() As Report
        Dim rep As New Report()

        For Each row As UltraGridRow In UltraGrid1.Rows
            row.Hidden = True
        Next

        For Each row As UltraGridRow In UltraGrid1.Rows
            row.Hidden = False
            Dim sec As ISection = rep.AddSection()
            AddHeader(sec, "Please Enter your Header Text here")
            UltraGridDocumentExporter1.AutoSize = Infragistics.Win.UltraWinGrid.DocumentExport.AutoSize.None
            UltraGridDocumentExporter1.Export(UltraGrid1, sec)
            AddFoother(sec, "Please Enter your Footer Text here")
            row.Hidden = True
        Next
        For Each row As UltraGridRow In UltraGrid1.Rows
            row.Hidden = False
        Next

        Return rep
    End Function


    Private Sub AddHeader(ByRef sec As ISection, ByVal text As String)
        Dim header As ISectionHeader = sec.AddHeader()
        header.Height = 20
        Dim headerText As IText = header.AddText(0, 0)
        headerText.Style = New Style(New Infragistics.Documents.Graphics.Font("Ariel", 12.0F), Infragistics.Documents.Graphics.Brushes.Black)
        headerText.Alignment = New TextAlignment(Alignment.Left, Alignment.Middle)
        headerText.AddContent(text)

    End Sub

    Private Sub AddFoother(ByRef sec As ISection, ByVal text As String)
        Dim footer As ISectionFooter = sec.AddFooter()
        footer.Height = 20
        Dim footerText As IText = footer.AddText(0, 0)
        footerText.Style = New Style(New Infragistics.Documents.Graphics.Font("Ariel", 12.0F), Infragistics.Documents.Graphics.Brushes.Black)
        footerText.Alignment = New TextAlignment(Alignment.Right, Alignment.Middle)
        footerText.AddContent(text)
    End Sub

    Private Sub UltraButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UltraButton1.Click
        Dim rep As Report = GenerateReport()
        pages = rep.Generate()
        currentPrintPageNumber = 0



        Me.UltraPrintPreviewDialog1.ShowDialog(Me)
        rep.Publish("Test.pdf", Infragistics.Documents.Report.FileFormat.PDF)
        Process.Start("Test.pdf")


    End Sub

    Private Sub UltraPrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles UltraPrintDocument1.PrintPage
        ' Create a new Document Graphics object based on the printer page graphics. 
        Dim reportGraphics As New Infragistics.Documents.Graphics.Graphics(e.Graphics)

        ' Save the state of the Graphics object So we can restore it later. 
        reportGraphics.SaveState()

        ' Get the page margins in points. 
        Dim leftMarginInPoints As Single = (e.MarginBounds.Left / 100.0F) * 72.0F
        Dim topMarginInPoints As Single = (e.MarginBounds.Top / 100.0F) * 72.0F

        ' Get the available print width and height in points. This is the size
        ' of the printable area of the page inside the margins. 
        Dim availablePrintWidth As Single = (e.MarginBounds.Width / 100.0F) * 72.0F
        Dim availablePrintHeight As Single = (e.MarginBounds.Height / 100.0F) * 72.0F

        ' Use a translate to shift the report page drawing inside the printer page margins. 
        reportGraphics.Translate(leftMarginInPoints, topMarginInPoints)

        ' Get the currently printing report page.
        Dim reportPage As IProjectionPage = pages(Me.currentPrintPageNumber)

        ' Scale the report page so that it fits inside the available print area. 
        Dim widthRatio As Single = availablePrintWidth / reportPage.Width
        Dim heightRatio As Single = availablePrintHeight / reportPage.Height
        reportGraphics.Scale(widthRatio, heightRatio)

        ' Draw the page. 
        reportPage.Draw(reportGraphics)

        ' Restore the Graphics settings. 
        reportGraphics.RestoreState()

        ' Increment the page number. 
        currentPrintPageNumber += 1

        ' If this is the last page, set HasMorePages to false. 

        e.HasMorePages = currentPrintPageNumber < (pages.Count)
        If Not (currentPrintPageNumber < (pages.Count)) Then
            currentPrintPageNumber = 0
        End If

    End Sub
End Class
